# Getestet mit Python 3.11.6

import pyaudio  # nötig: pip install pyaudio
import numpy  # nötig: pip install numpy
import math
import random

p = pyaudio.PyAudio()

sr = 44100

stream = p.open(format=pyaudio.paInt16,
                channels=1,
                rate=sr,
                output=True)

f = 880.0
df = 100.0

results : list[bool] = []  # ": list[bool]" gegen rote Typen-Warnungskringel ;-)

while True:
    rf = 0.01 * random.randint(-1000,1000)
    f1 = f + rf
    f2 = f1 + df
    r = random.randint(0,1)
    if r == 1:
        f1, f2 = f2, f1
    samples : list[float] = []  # ": list[float]" gegen rote Typen-Warnungskringel ;-)
    for i in range(int(sr/4)):
        samples.append(int(32000.0*math.sin(2.0*math.pi*i*f1/sr)))
    for i in range(int(sr/4)):
        samples.append(0)   
    for i in range(int(sr/4)):
        samples.append(int(32000.0*math.sin(2.0*math.pi*i*f2/sr))) 
    stream.write(numpy.array(samples).tobytes())
    a = input('Welcher war höher? (1 oder 2, dann Return-Taste) ')
    if a == '1':  # Dies ließe sich eleganter schreiben, wenn man a auf 0 und 1 mappt: results.append(r == a)
        if r == 1:
            results.append(True)
        else:
            results.append(False)
    elif a == '2':
        if r == 0:
            results.append(True)
        else:
            results.append(False)
    else:
        break
    if len(results) > 10:
        del results[0]
        a = 0
        for z in results:
            if z:
                a += 1  # Das ginge auch "pythonesk" statt mit einer for-Schleife!
        print(a/10.0, df)
        if a > 7:
            df *= 0.9
        else:
            df *= 1.1

stream.stop_stream()
stream.close()

p.terminate()